unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs;

type
  TForm2 = class(TForm)
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  TheRegion: HRGN;        // holds the elliptical region

implementation

{$R *.dfm}

procedure TForm2.FormPaint(Sender: TObject);
begin
  {erase the current image on the form}
  Canvas.Brush.Color := clBtnFace;
  Canvas.FillRect(BoundsRect);
  {outline the elliptical region in red}
  Canvas.Brush.Color := clRed;
  FrameRgn(Canvas.Handle, TheRegion, Canvas.Brush.Handle, 2, 2);
end;

procedure TForm2.FormResize(Sender: TObject);
begin
  {delete the current region, if it exists}
  if TheRegion<>0 then
  DeleteObject(TheRegion);
  {create a new elliptical region based on the boundaries of the client area}
  TheRegion := CreateEllipticRgnIndirect(ClientRect);
  {repaint the form}
  Repaint;
end;

procedure TForm2.FormDestroy(Sender: TObject);
begin
  {delete the elliptical region}
  DeleteObject(TheRegion);
end;

end.
